AppDomain.UnhandledException AppDomain.UnhandledException AppDomain.UnhandledException AppDomain.UnhandledException Event

Определение

Происходит, если выброшенное исключение остается не перехваченным.Occurs when an exception is not caught.

public:
 virtual event UnhandledExceptionEventHandler ^ UnhandledException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event UnhandledExceptionEventHandler UnhandledException;
member this.UnhandledException : UnhandledExceptionEventHandler 
Public Custom Event UnhandledException As UnhandledExceptionEventHandler 

Реализации

Атрибуты

Примеры

В следующем примере демонстрируется UnhandledException событий.The following example demonstrates the UnhandledException event. Он определяет обработчик событий MyHandler, которая вызывается каждый раз, когда необработанное исключение в домене приложения по умолчанию.It defines an event handler, MyHandler, that is invoked whenever an unhandled exception is thrown in the default application domain. Затем он создает два исключения.It then throws two exceptions. Первый обрабатывается try/catch блока.The first is handled by a try/catch block. Второй, остается необработанным и вызывает MyHandle подпрограммы перед завершением работы приложения.The second is unhandled and invokes the MyHandle routine before the application terminates.

// The example should be compiled with the /clr:pure compiler option.
using namespace System;
using namespace System::Security::Permissions;

public ref class Example
{


private:
   static void MyHandler(Object^ sender, UnhandledExceptionEventArgs^ args)
   {
      Exception^ e = dynamic_cast<Exception^>(args->ExceptionObject);
      Console::WriteLine( "MyHandler caught : {0}", e->Message );
      Console::WriteLine("Runtime terminating: {0}", args->IsTerminating);
   }
   
public: 
   [SecurityPermissionAttribute( SecurityAction::Demand, ControlAppDomain = true )]
   static void Main()
   {
      AppDomain^ currentDomain = AppDomain::CurrentDomain;
      currentDomain->UnhandledException += gcnew UnhandledExceptionEventHandler(Example::MyHandler);
      try
      {
         throw gcnew Exception("1");
      }
      catch (Exception^ e) 
      {
         Console::WriteLine( "Catch clause caught : {0}\n", e->Message );
      }

      throw gcnew Exception("2");
   }
};

void main()
{
   Example::Main();
}   
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()
//          at mainCRTStartup(String[] arguments)
using System;
using System.Security.Permissions;

public class Example 
{
   [SecurityPermission(SecurityAction.Demand, Flags=SecurityPermissionFlag.ControlAppDomain)]
   public static void Main()
   {
      AppDomain currentDomain = AppDomain.CurrentDomain;
      currentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyHandler);
      
      try {
         throw new Exception("1");
      } catch (Exception e) {
         Console.WriteLine("Catch clause caught : {0} \n", e.Message);
      }

      throw new Exception("2");
   }
   
   static void MyHandler(object sender, UnhandledExceptionEventArgs args) 
   {
      Exception e = (Exception) args.ExceptionObject;
      Console.WriteLine("MyHandler caught : " + e.Message);
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating);
   }
}
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()  
Module Example
   Sub Main()
      Dim currentDomain As AppDomain = AppDomain.CurrentDomain
      AddHandler currentDomain.UnhandledException, AddressOf MyHandler
      
      Try
         Throw New Exception("1")
      Catch e As Exception
         Console.WriteLine("Catch clause caught : " + e.Message)
         Console.WriteLine()
      End Try
      
      Throw New Exception("2")
   End Sub
   
   Sub MyHandler(sender As Object, args As UnhandledExceptionEventArgs)
      Dim e As Exception = DirectCast(args.ExceptionObject, Exception)
      Console.WriteLine("MyHandler caught : " + e.Message)
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating)
   End Sub
End Module
' The example displays the following output:
'       Catch clause caught : 1
'       
'       MyHandler caught : 2
'       Runtime terminating: True
'       
'       Unhandled Exception: System.Exception: 2
'          at Example.Main()

Комментарии

Это событие предоставляет уведомление о неперехваченных исключений.This event provides notification of uncaught exceptions. Он позволяет приложению записать в журнал сведения об исключении до обработчика по умолчанию система уведомляет об исключении пользователю и завершает работу приложения.It allows the application to log information about the exception before the system default handler reports the exception to the user and terminates the application. Если имеется достаточно сведений о состоянии приложения недоступен, другие действия можно выполнить — такие как сохранение данных программы для последующего восстановления.If sufficient information about the state of the application is available, other actions may be undertaken - such as saving program data for later recovery. Следует соблюдать осторожность, так как данные программы, которые могут быть повреждены, если исключения не обрабатываются.Caution is advised, because program data can become corrupted when exceptions are not handled.

Примечание

В .NET Framework версий 1.0 и 1.1, завершение работы приложения и параметры отладки отображаются для пользователя перед вызовом данного события, а не после.In the .NET Framework versions 1.0 and 1.1, application termination and debugging options are reported to the user before this event is raised, rather than after.

Это событие может быть обработано ни одним доменом приложения.This event can be handled in any application domain. Тем не менее не события обязательно в домене приложения, где произошло исключение.However, the event is not necessarily raised in the application domain where the exception occurred. Исключение не обрабатывается, только в том случае, если весь стек потока не находит обработчик, поэтому первое место возникновения события в домене приложения, где происходит поток был развернут.An exception is unhandled only if the entire stack for the thread has been unwound without finding an applicable exception handler, so the first place the event can be raised is in the application domain where the thread originated.

Примечание

В .NET Framework версий 1.0 и 1.1 это событие возникает только для домена приложения по умолчанию, который создается системой при запуске приложения.In the .NET Framework versions 1.0 and 1.1, this event occurs only for the default application domain that is created by the system when an application is started. Если приложение создает дополнительные домены приложений, указывается делегат для этого события в этих доменах приложений не оказывает влияния.If an application creates additional application domains, specifying a delegate for this event in those applications domains has no effect.

Если UnhandledException событие обрабатывается в домене приложения по умолчанию, оно генерируется там для любой необработанное исключение в любом потоке, независимо от того, какой домен приложения запущен поток.If the UnhandledException event is handled in the default application domain, it is raised there for any unhandled exception in any thread, no matter what application domain the thread started in. Если поток запущен в домене приложения, который имеет обработчик событий для UnhandledException, события в этом домене приложения.If the thread started in an application domain that has an event handler for UnhandledException, the event is raised in that application domain. Если этот домен приложения не по умолчанию домен приложения, и в домене приложения по умолчанию имеется также обработчик событий, событие возникает в обоих доменах приложений.If that application domain is not the default application domain, and there is also an event handler in the default application domain, the event is raised in both application domains.

Например предположим, что поток запускается в домена приложения «AD1», вызывает метод в домене приложения «AD2» и оттуда вызывает метод в домене приложения «AD3», где создается исключение.For example, suppose a thread starts in application domain "AD1", calls a method in application domain "AD2", and from there calls a method in application domain "AD3", where it throws an exception. Первый домен приложения, в котором UnhandledException может возникнуть событие является «AD1».The first application domain in which the UnhandledException event can be raised is "AD1". Если этот домен приложения не по умолчанию домен приложения, можно также создать событие в домене приложения по умолчанию.If that application domain is not the default application domain, the event can also be raised in the default application domain.

Примечание

Среда CLR приостанавливает прерывания потока при обработчики событий для UnhandledException событий выполняются.The common language runtime suspends thread aborts while event handlers for the UnhandledException event are executing.

Если обработчик событий использует ReliabilityContractAttribute атрибут с соответствующими флагами, обработчик событий рассматривается как область ограниченного выполнения.If the event handler has a ReliabilityContractAttribute attribute with the appropriate flags, the event handler is treated as a constrained execution region.

Начиная с .NET Framework 4.NET Framework 4, это событие не создается для исключения, привести к повреждению состояния процесса, таких как переполнение стека или нарушение прав доступа, если обработчик событий с точки зрения безопасности и не имеет HandleProcessCorruptedStateExceptionsAttribute атрибута.Starting with the .NET Framework 4.NET Framework 4, this event is not raised for exceptions that corrupt the state of the process, such as stack overflows or access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

В .NET Framework версий 1.0 и 1.1 необработанное исключение, возникающее в потоке, отличном от основного потока приложения перехватывается средой выполнения и поэтому не вызывает завершение работы приложения.In the .NET Framework versions 1.0 and 1.1, an unhandled exception that occurs in a thread other than the main application thread is caught by the runtime and therefore does not cause the application to terminate. Таким образом, существует возможность UnhandledException событие без прерывания приложений.Thus, it is possible for the UnhandledException event to be raised without the application terminating. Начиная с .NET Framework версии 2.0, эта поддержка необработанных исключений в потоках дочерних был удален, поскольку совокупный эффект такого автоматические сбои снижение производительности, данные повреждены и блокировки, которые трудно Отладка.Starting with the .NET Framework version 2.0, this backstop for unhandled exceptions in child threads was removed, because the cumulative effect of such silent failures included performance degradation, corrupted data, and lockups, all of which were difficult to debug. Дополнительные сведения, включая список случаев, в которых среда выполнения не завершает работу, см. в разделе исключения в управляемых потоках.For more information, including a list of cases in which the runtime does not terminate, see Exceptions in Managed Threads.

Чтобы зарегистрировать обработчик событий для этого события, необходимо иметь необходимые разрешения, или SecurityException возникает исключение.To register an event handler for this event, you must have the required permissions, or a SecurityException is thrown.

Дополнительные сведения об обработке событий см. в разделе обработка и вызов событий.For more information about handling events, see Handling and Raising Events.

Другие события для необработанных исключенийOther Events for Unhandled Exceptions

Для некоторых моделей приложения UnhandledException событий может быть вытеснен в другие события, если в основной поток приложения возникает необработанное исключение.For certain application models, the UnhandledException event can be preempted by other events if the unhandled exception occurs in the main application thread.

В приложениях, использующих Windows Forms, необработанные исключения в причина потока основного приложения Application.ThreadException возникает событие.In applications that use Windows Forms, unhandled exceptions in the main application thread cause the Application.ThreadException event to be raised. Если это событие обрабатывается, поведение по умолчанию является что необработанное исключение не завершает приложение, несмотря на то, что приложение остается в неизвестном состоянии.If this event is handled, the default behavior is that the unhandled exception does not terminate the application, although the application is left in an unknown state. В этом случае UnhandledException событие не происходит.In that case, the UnhandledException event is not raised. Это поведение можно изменить с помощью файла конфигурации приложения или с помощью Application.SetUnhandledExceptionMode метод, чтобы изменить режим, в котором UnhandledExceptionMode.ThrowException перед ThreadException подключить обработчик событий.This behavior can be changed by using the application configuration file, or by using the Application.SetUnhandledExceptionMode method to change the mode to UnhandledExceptionMode.ThrowException before the ThreadException event handler is hooked up. Это относится только к основного потока приложения.This applies only to the main application thread. UnhandledException События для необработанных исключений в других потоках.The UnhandledException event is raised for unhandled exceptions thrown in other threads.

Начиная с Microsoft Visual Studio 2005, платформа приложений Visual Basic предоставляет другое событие для необработанных исключений в основном потоке приложения.Starting with Microsoft Visual Studio 2005, the Visual Basic application framework provides another event for unhandled exceptions in the main application thread. См. в разделе WindowsFormsApplicationBase.UnhandledException событий.See the WindowsFormsApplicationBase.UnhandledException event. Это событие имеет объект аргументов события с тем же именем, что объект аргументы событий, используемый AppDomain.UnhandledException, но с различными свойствами.This event has an event arguments object with the same name as the event arguments object used by AppDomain.UnhandledException, but with different properties. В частности, этот объект аргументы событий имеет ExitApplication свойство, которое позволяет приложению продолжать выполнение, необработанное исключение игнорируется, поскольку (и покинет приложение в неизвестном состоянии).In particular, this event arguments object has an ExitApplication property that allows the application to continue running, ignoring the unhandled exception (and leaving the application in an unknown state). В этом случае AppDomain.UnhandledException событие не происходит.In that case, the AppDomain.UnhandledException event is not raised.

Безопасность

SecurityCriticalAttribute
Требует полного доверия для непосредственного вызывающего объекта.requires full trust for the immediate caller. Этот член не может использоваться частично доверенным или прозрачным кодом.This member cannot be used by partially trusted or transparent code.

Применяется к